/*###############################################################################
# Linux Management Providers (LMP), OS provider package
# Copyright (C) 2007 Ilsoo Byun, ETRI <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Khahramon NURIDDINOV, TUIT <qahramon0786@gmail.com>
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
###############################################################################*/

#ifndef OPENDRIM_OPERATINGSYSTEMDEFAULTRUNLEVEL_H_
#define OPENDRIM_OPERATINGSYSTEMDEFAULTRUNLEVEL_H_

#include <Instance.h>

const static char* OpenDRIM_OperatingSystemDefaultRunLevel_classnames[] = {"OpenDRIM_OperatingSystemDefaultRunLevel"};
static string OpenDRIM_OperatingSystemDefaultRunLevel_NAMESPACE = _NAMESPACE;

class OpenDRIM_OperatingSystemDefaultRunLevel {

public:
	
	string Caption;
	bool Caption_isNULL;
	
	string Description;
	bool Description_isNULL;
	
	string InstanceID;
	bool InstanceID_isNULL;
	
	string ElementName;
	bool ElementName_isNULL;
	
	string ConfigurationName;
	bool ConfigurationName_isNULL;
	
	unsigned short ChangeableType;
	bool ChangeableType_isNULL;
	
	unsigned char Value;
	bool Value_isNULL;
	
	OpenDRIM_OperatingSystemDefaultRunLevel() {
		Caption_isNULL = true;
		Description_isNULL = true;
		InstanceID_isNULL = true;
		ElementName_isNULL = true;
		ConfigurationName_isNULL = true;
		ChangeableType_isNULL = true;
		Value_isNULL = true;
	}
	
	~OpenDRIM_OperatingSystemDefaultRunLevel() {}
	
	string getKeys() const {
		return CF_toLowCase(".InstanceID=\"" + CF_quoteString(InstanceID) + "\"");
	}

	int getCaption(string& value) const {
		if (Caption_isNULL==true)
			return NOT_FOUND;
		value = Caption;
		return OK;
	}
	
	int setCaption(const string& newValue) {
		Caption = newValue;
		Caption_isNULL = false;
		return OK;
	}

	int getDescription(string& value) const {
		if (Description_isNULL==true)
			return NOT_FOUND;
		value = Description;
		return OK;
	}
	
	int setDescription(const string& newValue) {
		Description = newValue;
		Description_isNULL = false;
		return OK;
	}

	int getInstanceID(string& value) const {
		if (InstanceID_isNULL==true)
			return NOT_FOUND;
		value = InstanceID;
		return OK;
	}
	
	int setInstanceID(const string& newValue) {
		InstanceID = newValue;
		InstanceID_isNULL = false;
		return OK;
	}

	int getElementName(string& value) const {
		if (ElementName_isNULL==true)
			return NOT_FOUND;
		value = ElementName;
		return OK;
	}
	
	int setElementName(const string& newValue) {
		ElementName = newValue;
		ElementName_isNULL = false;
		return OK;
	}

	int getConfigurationName(string& value) const {
		if (ConfigurationName_isNULL==true)
			return NOT_FOUND;
		value = ConfigurationName;
		return OK;
	}
	
	int setConfigurationName(const string& newValue) {
		ConfigurationName = newValue;
		ConfigurationName_isNULL = false;
		return OK;
	}

	int getChangeableType(unsigned short& value) const {
		if (ChangeableType_isNULL==true)
			return NOT_FOUND;
		value = ChangeableType;
		return OK;
	}
	
	int setChangeableType(const unsigned short& newValue) {
		ChangeableType = newValue;
		ChangeableType_isNULL = false;
		return OK;
	}

	int getValue(unsigned char& value) const {
		if (Value_isNULL==true)
			return NOT_FOUND;
		value = Value;
		return OK;
	}
	
	int setValue(const unsigned char& newValue) {
		Value = newValue;
		Value_isNULL = false;
		return OK;
	}

};

#endif /*OPENDRIM_OPERATINGSYSTEMDEFAULTRUNLEVEL_H_*/
