/*###############################################################################
# Linux Management Providers (LMP), OS provider package
# Copyright (C) 2007 Ilsoo Byun, ETRI <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Khahramon NURIDDINOV, TUIT <qahramon0786@gmail.com>
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
###############################################################################*/

#ifndef OPENDRIM_OPERATINGSYSTEMOPERATINGSYSTEMDEFAULTRUNLEVELACCESS_H_
#define OPENDRIM_OPERATINGSYSTEMOPERATINGSYSTEMDEFAULTRUNLEVELACCESS_H_

#include "OS_Common.h"

#include "OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel.h"
#include "assocOpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel.h"

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_load(const CMPIBroker* broker, string& errorMessage);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_unload(string& errorMessage);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel>& instances, const char** properties, string& errorMessage, const string& discriminant);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel& instance, const char** properties, string& errorMessage);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel& newInstance, const OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel& oldInstance, const char** properties, string& errorMessage);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel& instance, string& errorMessage);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel& instance, string& errorMessage);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_associatorSettingDataToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& SettingData_instance, const char** properties, vector<Instance>& ManagedElement_associatedInstances, string& errorMessage, const string& discriminant);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_associatorManagedElementToSettingData(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const char** properties, vector<Instance>& SettingData_associatedInstances, string& errorMessage, const string& discriminant);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_referenceSettingDataToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& SettingData_instance, const vector<Instance>& ManagedElement_instances, vector<OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel>& OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_instances, const char** properties, string& errorMessage, const string& discriminant);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_referenceManagedElementToSettingData(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const vector<Instance>& SettingData_instances, vector<OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel>& OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_instances, const char** properties, string& errorMessage, const string& discriminant);

int OS_OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel_populate(OpenDRIM_OperatingSystemOperatingSystemDefaultRunLevel& instance, string& errorMessage);

#endif /*OPENDRIM_OPERATINGSYSTEMOPERATINGSYSTEMDEFAULTRUNLEVELACCESS_H_*/
